// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from dataspeed_dbw_gazebo_demo:msg/BezierArray.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "dataspeed_dbw_gazebo_demo/msg/detail/bezier_array__functions.h"
#include "dataspeed_dbw_gazebo_demo/msg/detail/bezier_array__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace dataspeed_dbw_gazebo_demo
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void BezierArray_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) dataspeed_dbw_gazebo_demo::msg::BezierArray(_init);
}

void BezierArray_fini_function(void * message_memory)
{
  auto typed_message = static_cast<dataspeed_dbw_gazebo_demo::msg::BezierArray *>(message_memory);
  typed_message->~BezierArray();
}

size_t size_function__BezierArray__curves(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<dataspeed_dbw_gazebo_demo::msg::BezierCurve> *>(untyped_member);
  return member->size();
}

const void * get_const_function__BezierArray__curves(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<dataspeed_dbw_gazebo_demo::msg::BezierCurve> *>(untyped_member);
  return &member[index];
}

void * get_function__BezierArray__curves(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<dataspeed_dbw_gazebo_demo::msg::BezierCurve> *>(untyped_member);
  return &member[index];
}

void fetch_function__BezierArray__curves(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const dataspeed_dbw_gazebo_demo::msg::BezierCurve *>(
    get_const_function__BezierArray__curves(untyped_member, index));
  auto & value = *reinterpret_cast<dataspeed_dbw_gazebo_demo::msg::BezierCurve *>(untyped_value);
  value = item;
}

void assign_function__BezierArray__curves(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<dataspeed_dbw_gazebo_demo::msg::BezierCurve *>(
    get_function__BezierArray__curves(untyped_member, index));
  const auto & value = *reinterpret_cast<const dataspeed_dbw_gazebo_demo::msg::BezierCurve *>(untyped_value);
  item = value;
}

void resize_function__BezierArray__curves(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<dataspeed_dbw_gazebo_demo::msg::BezierCurve> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember BezierArray_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(dataspeed_dbw_gazebo_demo::msg::BezierArray, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "curves",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<dataspeed_dbw_gazebo_demo::msg::BezierCurve>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(dataspeed_dbw_gazebo_demo::msg::BezierArray, curves),  // bytes offset in struct
    nullptr,  // default value
    size_function__BezierArray__curves,  // size() function pointer
    get_const_function__BezierArray__curves,  // get_const(index) function pointer
    get_function__BezierArray__curves,  // get(index) function pointer
    fetch_function__BezierArray__curves,  // fetch(index, &value) function pointer
    assign_function__BezierArray__curves,  // assign(index, value) function pointer
    resize_function__BezierArray__curves  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers BezierArray_message_members = {
  "dataspeed_dbw_gazebo_demo::msg",  // message namespace
  "BezierArray",  // message name
  2,  // number of fields
  sizeof(dataspeed_dbw_gazebo_demo::msg::BezierArray),
  BezierArray_message_member_array,  // message members
  BezierArray_init_function,  // function to initialize message memory (memory has to be allocated)
  BezierArray_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t BezierArray_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &BezierArray_message_members,
  get_message_typesupport_handle_function,
  &dataspeed_dbw_gazebo_demo__msg__BezierArray__get_type_hash,
  &dataspeed_dbw_gazebo_demo__msg__BezierArray__get_type_description,
  &dataspeed_dbw_gazebo_demo__msg__BezierArray__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace dataspeed_dbw_gazebo_demo


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<dataspeed_dbw_gazebo_demo::msg::BezierArray>()
{
  return &::dataspeed_dbw_gazebo_demo::msg::rosidl_typesupport_introspection_cpp::BezierArray_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, dataspeed_dbw_gazebo_demo, msg, BezierArray)() {
  return &::dataspeed_dbw_gazebo_demo::msg::rosidl_typesupport_introspection_cpp::BezierArray_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
