// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/BrakeInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/BrakeInfoReport in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__BrakeInfoReport
{
  std_msgs__msg__Header header;
  /// Brake pedal
  /// Brake pedal percent, range 0 to 1
  float brake_pc;
  /// Brake torques (Nm)
  float brake_torque_request;
  float brake_torque_actual;
  /// Brake pressure (bar)
  float brake_pressure;
  /// Misc
  bool stationary;
} dbw_fca_msgs__msg__BrakeInfoReport;

// Struct for a sequence of dbw_fca_msgs__msg__BrakeInfoReport.
typedef struct dbw_fca_msgs__msg__BrakeInfoReport__Sequence
{
  dbw_fca_msgs__msg__BrakeInfoReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__BrakeInfoReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__BRAKE_INFO_REPORT__STRUCT_H_
