// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/Misc1Report.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'turn_signal'
#include "dbw_fca_msgs/msg/detail/turn_signal__struct.h"
// Member 'high_beam'
#include "dbw_fca_msgs/msg/detail/high_beam__struct.h"
// Member 'wiper'
#include "dbw_fca_msgs/msg/detail/wiper__struct.h"

/// Struct defined in msg/Misc1Report in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__Misc1Report
{
  std_msgs__msg__Header header;
  /// Turn Signal enumeration
  dbw_fca_msgs__msg__TurnSignal turn_signal;
  /// Highbeam headlights / flash to pass enumeration
  dbw_fca_msgs__msg__HighBeam high_beam;
  /// Front Windshield Wipers enumeration
  dbw_fca_msgs__msg__Wiper wiper;
  /// Buttons
  /// Cruise Control On/Off Toggle
  bool btn_cc_on_off;
  /// Cruise Control Resume
  bool btn_cc_res;
  /// Cruise Control Cancel
  bool btn_cc_cncl;
  /// Cruise Control Set+
  bool btn_cc_set_inc;
  /// Cruise Control Set-
  bool btn_cc_set_dec;
  /// Cruise Control Gap+
  bool btn_cc_gap_inc;
  /// Cruise Control Gap-
  bool btn_cc_gap_dec;
  /// Cruise Control Mode
  bool btn_cc_mode;
  /// Left D-Pad OK
  bool btn_ld_ok;
  /// Left D-Pad Up
  bool btn_ld_up;
  /// Left D-Pad Down
  bool btn_ld_down;
  /// Left D-Pad Left
  bool btn_ld_left;
  /// Left D-Pad Right
  bool btn_ld_right;
  /// Faults
  bool fault_bus;
  /// Doors
  bool door_rear_left;
  bool door_rear_right;
  bool door_trunk;
} dbw_fca_msgs__msg__Misc1Report;

// Struct for a sequence of dbw_fca_msgs__msg__Misc1Report.
typedef struct dbw_fca_msgs__msg__Misc1Report__Sequence
{
  dbw_fca_msgs__msg__Misc1Report * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__Misc1Report__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC1_REPORT__STRUCT_H_
