// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/ThrottleInfoReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'gear_num'
#include "dbw_fca_msgs/msg/detail/gear_num__struct.h"
// Member 'ignition'
#include "dbw_fca_msgs/msg/detail/ignition__struct.h"

/// Struct defined in msg/ThrottleInfoReport in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__ThrottleInfoReport
{
  std_msgs__msg__Header header;
  /// Throttle Pedal
  /// Throttle pedal percent, range 0 to 1
  float throttle_pc;
  /// Engine
  /// Driver Intended Axle Torque (Nm)
  float axle_torque;
  /// Gear Num
  /// Gear Number
  dbw_fca_msgs__msg__GearNum gear_num;
  /// Ignition status
  /// Ignition status (enum)
  dbw_fca_msgs__msg__Ignition ignition;
} dbw_fca_msgs__msg__ThrottleInfoReport;

// Struct for a sequence of dbw_fca_msgs__msg__ThrottleInfoReport.
typedef struct dbw_fca_msgs__msg__ThrottleInfoReport__Sequence
{
  dbw_fca_msgs__msg__ThrottleInfoReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__ThrottleInfoReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__THROTTLE_INFO_REPORT__STRUCT_H_
