// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_polaris_msgs:msg/BrakeReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_POLARIS_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
#define DBW_POLARIS_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'watchdog_counter'
#include "dbw_polaris_msgs/msg/detail/watchdog_counter__struct.h"

/// Struct defined in msg/BrakeReport in the package dbw_polaris_msgs.
typedef struct dbw_polaris_msgs__msg__BrakeReport
{
  std_msgs__msg__Header header;
  /// Braking torque (Nm)
  float torque_input;
  float torque_cmd;
  float torque_output;
  /// Status
  /// Enabled
  bool enabled;
  /// Driver override
  bool override;
  /// Driver activity
  bool driver;
  /// Command timeout
  bool timeout;
  /// Watchdog Counter
  dbw_polaris_msgs__msg__WatchdogCounter watchdog_counter;
  bool watchdog_braking;
  bool fault_wdc;
  /// Faults
  bool fault_ch1;
  bool fault_ch2;
  bool fault_power;
} dbw_polaris_msgs__msg__BrakeReport;

// Struct for a sequence of dbw_polaris_msgs__msg__BrakeReport.
typedef struct dbw_polaris_msgs__msg__BrakeReport__Sequence
{
  dbw_polaris_msgs__msg__BrakeReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_polaris_msgs__msg__BrakeReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_POLARIS_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
