// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_polaris_msgs:msg/ThrottleCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_POLARIS_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_
#define DBW_POLARIS_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CMD_NONE'.
enum
{
  dbw_polaris_msgs__msg__ThrottleCmd__CMD_NONE = 0
};

/// Constant 'CMD_PEDAL'.
/**
  * Unitless, range 0.20 to 0.80
 */
enum
{
  dbw_polaris_msgs__msg__ThrottleCmd__CMD_PEDAL = 1
};

/// Constant 'CMD_PERCENT'.
/**
  * Percent of maximum throttle, range 0 to 1
 */
enum
{
  dbw_polaris_msgs__msg__ThrottleCmd__CMD_PERCENT = 2
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/ThrottleCmd in the package dbw_polaris_msgs.
typedef struct dbw_polaris_msgs__msg__ThrottleCmd
{
  std_msgs__msg__Header header;
  /// Throttle pedal
  /// Options defined below
  float pedal_cmd;
  uint8_t pedal_cmd_type;
  /// Enable
  bool enable;
  /// Clear driver overrides
  bool clear;
  /// Ignore driver overrides
  bool ignore;
  /// Watchdog counter (optional)
  uint8_t count;
} dbw_polaris_msgs__msg__ThrottleCmd;

// Struct for a sequence of dbw_polaris_msgs__msg__ThrottleCmd.
typedef struct dbw_polaris_msgs__msg__ThrottleCmd__Sequence
{
  dbw_polaris_msgs__msg__ThrottleCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_polaris_msgs__msg__ThrottleCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_POLARIS_MSGS__MSG__DETAIL__THROTTLE_CMD__STRUCT_H_
