// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice
#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Request * msg)
{
  if (!msg) {
    return false;
  }
  // speed_limit
  // lateral_accel_limit
  // linear_accel
  // linear_decel
  // jerk_limit
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Request * msg)
{
  if (!msg) {
    return;
  }
  // speed_limit
  // lateral_accel_limit
  // linear_accel
  // linear_decel
  // jerk_limit
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Request * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // speed_limit
  if (lhs->speed_limit != rhs->speed_limit) {
    return false;
  }
  // lateral_accel_limit
  if (lhs->lateral_accel_limit != rhs->lateral_accel_limit) {
    return false;
  }
  // linear_accel
  if (lhs->linear_accel != rhs->linear_accel) {
    return false;
  }
  // linear_decel
  if (lhs->linear_decel != rhs->linear_decel) {
    return false;
  }
  // jerk_limit
  if (lhs->jerk_limit != rhs->jerk_limit) {
    return false;
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Request * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // speed_limit
  output->speed_limit = input->speed_limit;
  // lateral_accel_limit
  output->lateral_accel_limit = input->lateral_accel_limit;
  // linear_accel
  output->linear_accel = input->linear_accel;
  // linear_decel
  output->linear_decel = input->linear_decel;
  // jerk_limit
  output->jerk_limit = input->jerk_limit;
  return true;
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Request *
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request * msg = (ds_autonomy_msgs__srv__SetSpeedConstraints_Request *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Request));
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request * data = NULL;

  if (size) {
    data = (ds_autonomy_msgs__srv__SetSpeedConstraints_Request *)allocator.zero_allocate(size, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_autonomy_msgs__srv__SetSpeedConstraints_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_autonomy_msgs__srv__SetSpeedConstraints_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence *
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * array = (ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_autonomy_msgs__srv__SetSpeedConstraints_Request * data =
      (ds_autonomy_msgs__srv__SetSpeedConstraints_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_autonomy_msgs__srv__SetSpeedConstraints_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Response * msg)
{
  if (!msg) {
    return false;
  }
  // actual_speed_limit
  // actual_lateral_accel_limit
  // actual_linear_accel
  // actual_linear_decel
  // actual_jerk_limit
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Response * msg)
{
  if (!msg) {
    return;
  }
  // actual_speed_limit
  // actual_lateral_accel_limit
  // actual_linear_accel
  // actual_linear_decel
  // actual_jerk_limit
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Response * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // actual_speed_limit
  if (lhs->actual_speed_limit != rhs->actual_speed_limit) {
    return false;
  }
  // actual_lateral_accel_limit
  if (lhs->actual_lateral_accel_limit != rhs->actual_lateral_accel_limit) {
    return false;
  }
  // actual_linear_accel
  if (lhs->actual_linear_accel != rhs->actual_linear_accel) {
    return false;
  }
  // actual_linear_decel
  if (lhs->actual_linear_decel != rhs->actual_linear_decel) {
    return false;
  }
  // actual_jerk_limit
  if (lhs->actual_jerk_limit != rhs->actual_jerk_limit) {
    return false;
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Response * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // actual_speed_limit
  output->actual_speed_limit = input->actual_speed_limit;
  // actual_lateral_accel_limit
  output->actual_lateral_accel_limit = input->actual_lateral_accel_limit;
  // actual_linear_accel
  output->actual_linear_accel = input->actual_linear_accel;
  // actual_linear_decel
  output->actual_linear_decel = input->actual_linear_decel;
  // actual_jerk_limit
  output->actual_jerk_limit = input->actual_jerk_limit;
  return true;
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Response *
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response * msg = (ds_autonomy_msgs__srv__SetSpeedConstraints_Response *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Response));
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response * data = NULL;

  if (size) {
    data = (ds_autonomy_msgs__srv__SetSpeedConstraints_Response *)allocator.zero_allocate(size, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_autonomy_msgs__srv__SetSpeedConstraints_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_autonomy_msgs__srv__SetSpeedConstraints_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence *
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * array = (ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_autonomy_msgs__srv__SetSpeedConstraints_Response * data =
      (ds_autonomy_msgs__srv__SetSpeedConstraints_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_autonomy_msgs__srv__SetSpeedConstraints_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "ds_autonomy_msgs/srv/detail/set_speed_constraints__functions.h"

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(msg);
    return false;
  }
  // request
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__init(&msg->request, 0)) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(msg);
    return false;
  }
  // response
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__init(&msg->response, 0)) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(msg);
    return false;
  }
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__fini(&msg->request);
  // response
  ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__fini(&msg->response);
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Event * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Event * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Event *
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Event * msg = (ds_autonomy_msgs__srv__SetSpeedConstraints_Event *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Event));
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__init(ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Event * data = NULL;

  if (size) {
    data = (ds_autonomy_msgs__srv__SetSpeedConstraints_Event *)allocator.zero_allocate(size, sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__fini(ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence *
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * array = (ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence *)allocator.allocate(sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__destroy(ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__are_equal(const ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * lhs, const ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence__copy(
  const ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * input,
  ds_autonomy_msgs__srv__SetSpeedConstraints_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_autonomy_msgs__srv__SetSpeedConstraints_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_autonomy_msgs__srv__SetSpeedConstraints_Event * data =
      (ds_autonomy_msgs__srv__SetSpeedConstraints_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_autonomy_msgs__srv__SetSpeedConstraints_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_autonomy_msgs__srv__SetSpeedConstraints_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
