// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/GearReject.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'NONE'.
/**
  * Not rejected
 */
enum
{
  ds_dbw_msgs__msg__GearReject__NONE = 0
};

/// Constant 'FAULT'.
/**
  * System in fault state
 */
enum
{
  ds_dbw_msgs__msg__GearReject__FAULT = 1
};

/// Constant 'UNSUPPORTED'.
/**
  * Unsupported gear command
 */
enum
{
  ds_dbw_msgs__msg__GearReject__UNSUPPORTED = 2
};

/// Constant 'SHIFT_IN_PROGRESS'.
/**
  * Shift in progress
 */
enum
{
  ds_dbw_msgs__msg__GearReject__SHIFT_IN_PROGRESS = 3
};

/// Constant 'OVERRIDE'.
/**
  * Override on brake, throttle, or steering
 */
enum
{
  ds_dbw_msgs__msg__GearReject__OVERRIDE = 4
};

/// Constant 'BRAKE_HOLD'.
/**
  * Brake hold time depleted, stay in park
 */
enum
{
  ds_dbw_msgs__msg__GearReject__BRAKE_HOLD = 5
};

/// Constant 'VEHICLE_SPEED'.
/**
  * Excessive vehicle speed
 */
enum
{
  ds_dbw_msgs__msg__GearReject__VEHICLE_SPEED = 6
};

/// Constant 'VEHICLE'.
/**
  * Rejected by vehicle (try pressing the brakes)
 */
enum
{
  ds_dbw_msgs__msg__GearReject__VEHICLE = 7
};

/// Struct defined in msg/GearReject in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__GearReject
{
  uint8_t value;
} ds_dbw_msgs__msg__GearReject;

// Struct for a sequence of ds_dbw_msgs__msg__GearReject.
typedef struct ds_dbw_msgs__msg__GearReject__Sequence
{
  ds_dbw_msgs__msg__GearReject * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__GearReject__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__GEAR_REJECT__STRUCT_H_
