// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/UlcCmd.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CMD_NONE'.
/**
  * Command types
 */
enum
{
  ds_dbw_msgs__msg__UlcCmd__CMD_NONE = 0
};

/// Constant 'CMD_VELOCITY'.
/**
  * m/s
 */
enum
{
  ds_dbw_msgs__msg__UlcCmd__CMD_VELOCITY = 1
};

/// Constant 'CMD_ACCEL'.
/**
  * m/s^2
 */
enum
{
  ds_dbw_msgs__msg__UlcCmd__CMD_ACCEL = 2
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/UlcCmd in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__UlcCmd
{
  std_msgs__msg__Header header;
  /// ULC command
  /// Command, changes with cmd_type
  float cmd;
  /// m/s^2, rate limit for velocity command increase, 0 for default, INFINITY for no limit
  float limit_accel;
  /// m/s^2, rate limit for velocity command decrease, 0 for default, INFINITY for no limit
  float limit_decel;
  /// m/s^3, rate limit for acceleration command increase, 0 for default, INFINITY for no limit
  float limit_jerk_throttle;
  /// m/s^3, rate limit for acceleration command decrease, 0 for default, INFINITY for no limit
  float limit_jerk_brake;
  uint8_t cmd_type;
  /// Enable
  bool enable;
  /// Clear latched overrides
  bool clear;
  /// Options
  bool enable_shift;
  bool enable_shift_park;
  bool coast_decel;
} ds_dbw_msgs__msg__UlcCmd;

// Struct for a sequence of ds_dbw_msgs__msg__UlcCmd.
typedef struct ds_dbw_msgs__msg__UlcCmd__Sequence
{
  ds_dbw_msgs__msg__UlcCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__UlcCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_
