// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from oxts_msgs:msg/ImuBias.idl
// generated code does not contain a copyright notice

#ifndef OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_H_
#define OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'accel'
// Member 'gyro'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in msg/ImuBias in the package oxts_msgs.
/**
  * OxTS IMU bias message
 */
typedef struct oxts_msgs__msg__ImuBias
{
  /// Header
  /// Standard ROS message header
  std_msgs__msg__Header header;
  /// Accelerometer biases (x, y, z)
  geometry_msgs__msg__Vector3 accel;
  /// Gyroscope biases (x, y, z)
  geometry_msgs__msg__Vector3 gyro;
} oxts_msgs__msg__ImuBias;

// Struct for a sequence of oxts_msgs__msg__ImuBias.
typedef struct oxts_msgs__msg__ImuBias__Sequence
{
  oxts_msgs__msg__ImuBias * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} oxts_msgs__msg__ImuBias__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_H_
