// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_ulc_msgs:msg/UlcCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'YAW_RATE_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcCmd__YAW_RATE_MODE = 0
};

/// Constant 'CURVATURE_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcCmd__CURVATURE_MODE = 1
};

/// Constant 'SPEED_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcCmd__SPEED_MODE = 0
};

/// Constant 'ACCEL_MODE'.
enum
{
  dataspeed_ulc_msgs__msg__UlcCmd__ACCEL_MODE = 1
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/UlcCmd in the package dataspeed_ulc_msgs.
typedef struct dataspeed_ulc_msgs__msg__UlcCmd
{
  std_msgs__msg__Header header;
  bool clear;
  bool enable_pedals;
  bool enable_steering;
  bool enable_shifting;
  bool shift_from_park;
  bool coast_decel;
  double linear_velocity;
  double accel_cmd;
  double linear_accel;
  double linear_decel;
  double jerk_limit_throttle;
  double jerk_limit_brake;
  double yaw_command;
  double angular_accel;
  double lateral_accel;
  uint8_t steering_mode;
  uint8_t pedals_mode;
} dataspeed_ulc_msgs__msg__UlcCmd;

// Struct for a sequence of dataspeed_ulc_msgs__msg__UlcCmd.
typedef struct dataspeed_ulc_msgs__msg__UlcCmd__Sequence
{
  dataspeed_ulc_msgs__msg__UlcCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_ulc_msgs__msg__UlcCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__STRUCT_H_
