// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_fca_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_H_
#define DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'cmd'
#include "dbw_fca_msgs/msg/detail/turn_signal__struct.h"
// Member 'door'
#include "dbw_fca_msgs/msg/detail/door_cmd__struct.h"
// Member 'ft_drv_temp'
// Member 'ft_psg_temp'
#include "dbw_fca_msgs/msg/detail/front_temp__struct.h"
// Member 'ft_fan_speed'
#include "dbw_fca_msgs/msg/detail/front_fan_speed__struct.h"
// Member 'max_ac'
// Member 'ac'
// Member 'ft_hvac'
// Member 'auto_md'
// Member 'recirc'
// Member 'sync'
// Member 'r_defr'
// Member 'f_defr'
// Member 'heated_steering_wheel'
#include "dbw_fca_msgs/msg/detail/hvac_button_cmd__struct.h"
// Member 'vent_mode'
#include "dbw_fca_msgs/msg/detail/vent_mode__struct.h"
// Member 'fl_heated_seat'
// Member 'fl_vented_seat'
// Member 'fr_heated_seat'
// Member 'fr_vented_seat'
#include "dbw_fca_msgs/msg/detail/hvac_seat__struct.h"

/// Struct defined in msg/MiscCmd in the package dbw_fca_msgs.
typedef struct dbw_fca_msgs__msg__MiscCmd
{
  std_msgs__msg__Header header;
  /// Turn signal command enumeration
  dbw_fca_msgs__msg__TurnSignal cmd;
  /// Door open/close command
  dbw_fca_msgs__msg__DoorCmd door;
  /// Front Driver Temperature Command
  dbw_fca_msgs__msg__FrontTemp ft_drv_temp;
  /// Front Passenger Temperature Command
  dbw_fca_msgs__msg__FrontTemp ft_psg_temp;
  /// Front Fan Speed Command
  dbw_fca_msgs__msg__FrontFanSpeed ft_fan_speed;
  /// Front Button Command
  dbw_fca_msgs__msg__HvacButtonCmd max_ac;
  dbw_fca_msgs__msg__HvacButtonCmd ac;
  dbw_fca_msgs__msg__HvacButtonCmd ft_hvac;
  dbw_fca_msgs__msg__HvacButtonCmd auto_md;
  dbw_fca_msgs__msg__HvacButtonCmd recirc;
  dbw_fca_msgs__msg__HvacButtonCmd sync;
  dbw_fca_msgs__msg__HvacButtonCmd r_defr;
  dbw_fca_msgs__msg__HvacButtonCmd f_defr;
  /// Front Vent Mode Command
  dbw_fca_msgs__msg__VentMode vent_mode;
  /// Heated Steering Wheel Command
  dbw_fca_msgs__msg__HvacButtonCmd heated_steering_wheel;
  /// Front Left Heated Seat Command
  dbw_fca_msgs__msg__HvacSeat fl_heated_seat;
  /// Front Left Vented Seat Command
  dbw_fca_msgs__msg__HvacSeat fl_vented_seat;
  /// Front Right Heated Seat Command
  dbw_fca_msgs__msg__HvacSeat fr_heated_seat;
  /// Front Right Vented Seat Command
  dbw_fca_msgs__msg__HvacSeat fr_vented_seat;
} dbw_fca_msgs__msg__MiscCmd;

// Struct for a sequence of dbw_fca_msgs__msg__MiscCmd.
typedef struct dbw_fca_msgs__msg__MiscCmd__Sequence
{
  dbw_fca_msgs__msg__MiscCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_fca_msgs__msg__MiscCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_H_
