// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from dbw_fca_msgs:msg/WatchdogCounter.idl
// generated code does not contain a copyright notice

#include "dbw_fca_msgs/msg/detail/watchdog_counter__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
const rosidl_type_hash_t *
dbw_fca_msgs__msg__WatchdogCounter__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x8d, 0xfe, 0x0e, 0xb1, 0x5a, 0xa6, 0x5a, 0xcc,
      0x68, 0x6a, 0xe5, 0xc9, 0x81, 0x8c, 0x6c, 0x85,
      0x6b, 0x99, 0x40, 0x9c, 0x14, 0xd1, 0x4e, 0xf6,
      0xb7, 0x73, 0x6c, 0x30, 0x5e, 0xea, 0x86, 0xc1,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char dbw_fca_msgs__msg__WatchdogCounter__TYPE_NAME[] = "dbw_fca_msgs/msg/WatchdogCounter";

// Define type names, field names, and default values
static char dbw_fca_msgs__msg__WatchdogCounter__FIELD_NAME__source[] = "source";

static rosidl_runtime_c__type_description__Field dbw_fca_msgs__msg__WatchdogCounter__FIELDS[] = {
  {
    {dbw_fca_msgs__msg__WatchdogCounter__FIELD_NAME__source, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
dbw_fca_msgs__msg__WatchdogCounter__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {dbw_fca_msgs__msg__WatchdogCounter__TYPE_NAME, 32, 32},
      {dbw_fca_msgs__msg__WatchdogCounter__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "uint8 source\n"
  "\n"
  "uint8 NONE=0               # No source for watchdog counter fault\n"
  "uint8 OTHER_BRAKE=1        # Fault determined by brake controller\n"
  "uint8 OTHER_THROTTLE=2     # Fault determined by throttle controller\n"
  "uint8 OTHER_STEERING=3     # Fault determined by steering controller\n"
  "uint8 BRAKE_COUNTER=4      # Brake command counter failed to increment\n"
  "uint8 BRAKE_DISABLED=5     # Brake transition to disabled while in gear or moving\n"
  "uint8 BRAKE_COMMAND=6      # Brake command timeout after 100ms\n"
  "uint8 BRAKE_REPORT=7       # Brake report timeout after 100ms\n"
  "uint8 THROTTLE_COUNTER=8   # Throttle command counter failed to increment\n"
  "uint8 THROTTLE_DISABLED=9  # Throttle transition to disabled while in gear or moving\n"
  "uint8 THROTTLE_COMMAND=10  # Throttle command timeout after 100ms\n"
  "uint8 THROTTLE_REPORT=11   # Throttle report timeout after 100ms\n"
  "uint8 STEERING_COUNTER=12  # Steering command counter failed to increment\n"
  "uint8 STEERING_DISABLED=13 # Steering transition to disabled while in gear or moving\n"
  "uint8 STEERING_COMMAND=14  # Steering command timeout after 100ms\n"
  "uint8 STEERING_REPORT=15   # Steering report timeout after 100ms";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
dbw_fca_msgs__msg__WatchdogCounter__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {dbw_fca_msgs__msg__WatchdogCounter__TYPE_NAME, 32, 32},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1142, 1142},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
dbw_fca_msgs__msg__WatchdogCounter__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *dbw_fca_msgs__msg__WatchdogCounter__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
