// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from dbw_polaris_msgs:msg/WatchdogCounter.idl
// generated code does not contain a copyright notice

#include "dbw_polaris_msgs/msg/detail/watchdog_counter__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
const rosidl_type_hash_t *
dbw_polaris_msgs__msg__WatchdogCounter__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x6f, 0xd7, 0x1e, 0xec, 0x64, 0xf4, 0xc7, 0x0a,
      0xf5, 0x02, 0xc6, 0x1e, 0x83, 0x54, 0x9d, 0x74,
      0x17, 0xdd, 0x03, 0x7e, 0x37, 0xce, 0x5a, 0x87,
      0x1c, 0x83, 0xaa, 0xcf, 0xe7, 0x2e, 0x45, 0x6a,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char dbw_polaris_msgs__msg__WatchdogCounter__TYPE_NAME[] = "dbw_polaris_msgs/msg/WatchdogCounter";

// Define type names, field names, and default values
static char dbw_polaris_msgs__msg__WatchdogCounter__FIELD_NAME__source[] = "source";

static rosidl_runtime_c__type_description__Field dbw_polaris_msgs__msg__WatchdogCounter__FIELDS[] = {
  {
    {dbw_polaris_msgs__msg__WatchdogCounter__FIELD_NAME__source, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
dbw_polaris_msgs__msg__WatchdogCounter__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {dbw_polaris_msgs__msg__WatchdogCounter__TYPE_NAME, 36, 36},
      {dbw_polaris_msgs__msg__WatchdogCounter__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "uint8 source\n"
  "\n"
  "uint8 NONE=0               # No source for watchdog counter fault\n"
  "uint8 OTHER_BRAKE=1        # Fault determined by brake controller\n"
  "uint8 OTHER_THROTTLE=2     # Fault determined by throttle controller\n"
  "uint8 OTHER_STEERING=3     # Fault determined by steering controller\n"
  "uint8 BRAKE_COUNTER=4      # Brake command counter failed to increment\n"
  "uint8 BRAKE_DISABLED=5     # Brake transition to disabled while in gear or moving\n"
  "uint8 BRAKE_COMMAND=6      # Brake command timeout after 100ms\n"
  "uint8 BRAKE_REPORT=7       # Brake report timeout after 100ms\n"
  "uint8 THROTTLE_COUNTER=8   # Throttle command counter failed to increment\n"
  "uint8 THROTTLE_DISABLED=9  # Throttle transition to disabled while in gear or moving\n"
  "uint8 THROTTLE_COMMAND=10  # Throttle command timeout after 100ms\n"
  "uint8 THROTTLE_REPORT=11   # Throttle report timeout after 100ms\n"
  "uint8 STEERING_COUNTER=12  # Steering command counter failed to increment\n"
  "uint8 STEERING_DISABLED=13 # Steering transition to disabled while in gear or moving\n"
  "uint8 STEERING_COMMAND=14  # Steering command timeout after 100ms\n"
  "uint8 STEERING_REPORT=15   # Steering report timeout after 100ms";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
dbw_polaris_msgs__msg__WatchdogCounter__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {dbw_polaris_msgs__msg__WatchdogCounter__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1142, 1142},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
dbw_polaris_msgs__msg__WatchdogCounter__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *dbw_polaris_msgs__msg__WatchdogCounter__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
