// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__STRUCT_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Request __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Request __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetSpeedConstraints_Request_
{
  using Type = SetSpeedConstraints_Request_<ContainerAllocator>;

  explicit SetSpeedConstraints_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_limit = 0.0;
      this->lateral_accel_limit = 0.0;
      this->linear_accel = 0.0;
      this->linear_decel = 0.0;
      this->jerk_limit = 0.0;
    }
  }

  explicit SetSpeedConstraints_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_limit = 0.0;
      this->lateral_accel_limit = 0.0;
      this->linear_accel = 0.0;
      this->linear_decel = 0.0;
      this->jerk_limit = 0.0;
    }
  }

  // field types and members
  using _speed_limit_type =
    double;
  _speed_limit_type speed_limit;
  using _lateral_accel_limit_type =
    double;
  _lateral_accel_limit_type lateral_accel_limit;
  using _linear_accel_type =
    double;
  _linear_accel_type linear_accel;
  using _linear_decel_type =
    double;
  _linear_decel_type linear_decel;
  using _jerk_limit_type =
    double;
  _jerk_limit_type jerk_limit;

  // setters for named parameter idiom
  Type & set__speed_limit(
    const double & _arg)
  {
    this->speed_limit = _arg;
    return *this;
  }
  Type & set__lateral_accel_limit(
    const double & _arg)
  {
    this->lateral_accel_limit = _arg;
    return *this;
  }
  Type & set__linear_accel(
    const double & _arg)
  {
    this->linear_accel = _arg;
    return *this;
  }
  Type & set__linear_decel(
    const double & _arg)
  {
    this->linear_decel = _arg;
    return *this;
  }
  Type & set__jerk_limit(
    const double & _arg)
  {
    this->jerk_limit = _arg;
    return *this;
  }

  // constant declarations
  static constexpr double MIN_LATERAL_ACCEL =
    1.0;
  static constexpr double MAX_LATERAL_ACCEL =
    6.0;
  static constexpr double MIN_LIN_ACCEL =
    0.5;
  static constexpr double MAX_LIN_ACCEL =
    3.0;
  static constexpr double MIN_LIN_DECEL =
    1.0;
  static constexpr double MAX_LIN_DECEL =
    6.0;
  static constexpr double MIN_JERK =
    0.25;
  static constexpr double MAX_JERK =
    4.0;

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Request
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Request
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetSpeedConstraints_Request_ & other) const
  {
    if (this->speed_limit != other.speed_limit) {
      return false;
    }
    if (this->lateral_accel_limit != other.lateral_accel_limit) {
      return false;
    }
    if (this->linear_accel != other.linear_accel) {
      return false;
    }
    if (this->linear_decel != other.linear_decel) {
      return false;
    }
    if (this->jerk_limit != other.jerk_limit) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetSpeedConstraints_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetSpeedConstraints_Request_

// alias to use template instance with default allocator
using SetSpeedConstraints_Request =
  ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MIN_LATERAL_ACCEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MAX_LATERAL_ACCEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MIN_LIN_ACCEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MAX_LIN_ACCEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MIN_LIN_DECEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MAX_LIN_DECEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MIN_JERK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr double SetSpeedConstraints_Request_<ContainerAllocator>::MAX_JERK;
#endif  // __cplusplus < 201703L

}  // namespace srv

}  // namespace ds_autonomy_msgs


#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Response __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Response __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetSpeedConstraints_Response_
{
  using Type = SetSpeedConstraints_Response_<ContainerAllocator>;

  explicit SetSpeedConstraints_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->actual_speed_limit = 0.0;
      this->actual_lateral_accel_limit = 0.0;
      this->actual_linear_accel = 0.0;
      this->actual_linear_decel = 0.0;
      this->actual_jerk_limit = 0.0;
    }
  }

  explicit SetSpeedConstraints_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->actual_speed_limit = 0.0;
      this->actual_lateral_accel_limit = 0.0;
      this->actual_linear_accel = 0.0;
      this->actual_linear_decel = 0.0;
      this->actual_jerk_limit = 0.0;
    }
  }

  // field types and members
  using _actual_speed_limit_type =
    double;
  _actual_speed_limit_type actual_speed_limit;
  using _actual_lateral_accel_limit_type =
    double;
  _actual_lateral_accel_limit_type actual_lateral_accel_limit;
  using _actual_linear_accel_type =
    double;
  _actual_linear_accel_type actual_linear_accel;
  using _actual_linear_decel_type =
    double;
  _actual_linear_decel_type actual_linear_decel;
  using _actual_jerk_limit_type =
    double;
  _actual_jerk_limit_type actual_jerk_limit;

  // setters for named parameter idiom
  Type & set__actual_speed_limit(
    const double & _arg)
  {
    this->actual_speed_limit = _arg;
    return *this;
  }
  Type & set__actual_lateral_accel_limit(
    const double & _arg)
  {
    this->actual_lateral_accel_limit = _arg;
    return *this;
  }
  Type & set__actual_linear_accel(
    const double & _arg)
  {
    this->actual_linear_accel = _arg;
    return *this;
  }
  Type & set__actual_linear_decel(
    const double & _arg)
  {
    this->actual_linear_decel = _arg;
    return *this;
  }
  Type & set__actual_jerk_limit(
    const double & _arg)
  {
    this->actual_jerk_limit = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Response
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Response
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetSpeedConstraints_Response_ & other) const
  {
    if (this->actual_speed_limit != other.actual_speed_limit) {
      return false;
    }
    if (this->actual_lateral_accel_limit != other.actual_lateral_accel_limit) {
      return false;
    }
    if (this->actual_linear_accel != other.actual_linear_accel) {
      return false;
    }
    if (this->actual_linear_decel != other.actual_linear_decel) {
      return false;
    }
    if (this->actual_jerk_limit != other.actual_jerk_limit) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetSpeedConstraints_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetSpeedConstraints_Response_

// alias to use template instance with default allocator
using SetSpeedConstraints_Response =
  ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ds_autonomy_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Event __attribute__((deprecated))
#else
# define DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Event __declspec(deprecated)
#endif

namespace ds_autonomy_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetSpeedConstraints_Event_
{
  using Type = SetSpeedConstraints_Event_<ContainerAllocator>;

  explicit SetSpeedConstraints_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetSpeedConstraints_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetSpeedConstraints_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<ds_autonomy_msgs::srv::SetSpeedConstraints_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Event
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_autonomy_msgs__srv__SetSpeedConstraints_Event
    std::shared_ptr<ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetSpeedConstraints_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetSpeedConstraints_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetSpeedConstraints_Event_

// alias to use template instance with default allocator
using SetSpeedConstraints_Event =
  ds_autonomy_msgs::srv::SetSpeedConstraints_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ds_autonomy_msgs

namespace ds_autonomy_msgs
{

namespace srv
{

struct SetSpeedConstraints
{
  using Request = ds_autonomy_msgs::srv::SetSpeedConstraints_Request;
  using Response = ds_autonomy_msgs::srv::SetSpeedConstraints_Response;
  using Event = ds_autonomy_msgs::srv::SetSpeedConstraints_Event;
};

}  // namespace srv

}  // namespace ds_autonomy_msgs

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__STRUCT_HPP_
