// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/ThrottleReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__struct.h"

/// Struct defined in msg/ThrottleReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__ThrottleReport
{
  std_msgs__msg__Header header;
  /// Options defined in BrakeCmd message
  uint8_t cmd_type;
  /// Percent (0-100)
  float percent_input;
  /// Percent (0-100)
  float percent_cmd;
  /// Percent (0-100)
  float percent_output;
  bool limiting_value;
  bool limiting_rate;
  bool external_control;
  /// Status
  /// Ready to be enabled
  bool ready;
  /// Enabled
  bool enabled;
  /// Active override
  bool override_active;
  /// Override from other system
  bool override_other;
  /// Latched override
  bool override_latched;
  /// Command timeout (of valid messages)
  bool timeout;
  /// Fault of any kind
  bool fault;
  /// CRC error on most recent command
  bool bad_crc;
  /// Repeated rolling counter on most recent command
  bool bad_rc;
  /// Start of slower secondary report #####
  /// Degradation of any kind
  bool degraded;
  /// Calculated limit vs vehicle speed
  /// percent
  float limit_value;
  /// Command source
  ds_dbw_msgs__msg__CmdSrc cmd_src;
} ds_dbw_msgs__msg__ThrottleReport;

// Struct for a sequence of ds_dbw_msgs__msg__ThrottleReport.
typedef struct ds_dbw_msgs__msg__ThrottleReport__Sequence
{
  ds_dbw_msgs__msg__ThrottleReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__ThrottleReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_H_
